/*
 * Created on Nov 25, 2004
 *
 * simple test program.
 * It uses a properties file (written in unicode) so that text (hebrew) is not lost on not hebrew enabled systems.
 * It then writes to a file and then reads from it.
 * This is done using encoding so we can control what we write and how we read/write.
 * 
 * usage:
 * 		-inenc:[enter encoding here] - I use ISO-8859-8
 * 		-outenc:[enter encoding here] - I use ISO-8859-8
 * 		-outFile:[enter file name]
 */
package test;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.util.Properties;

/**
 * @author ilan
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Util
{
	
	private static String Verification_String = "";
	Properties defaultProps = new Properties();
	
	private String m_inEnc;
	private String m_outEnc;
	private String m_outFile;
	
	/**
	 * 
	 */
	public Util(String[] args)
	{
		handleArgs(args);
		readProperiesFile();
		writeFile(m_outFile, m_outEnc, Verification_String);
		String st = readFile(m_outFile, m_inEnc);
		if (st.equals(Verification_String))
		{
			System.out.println("All is well, Thank you for using me!!!");
		}
		else
		{
			System.out.println("Sorry string do not match original" );
			System.out.println("Orig = " + Verification_String);
			System.out.println("String read From file = " + st);
		}
	}
	
	private void handleArgs(String[] args)
	{
		for (int i = 0; i < args.length; i++)
		{
			String arg = args[i];
			if (arg.startsWith("-inenc:"))
			{
				m_inEnc = arg.substring(7);
			} else if (arg.startsWith("-outenc:"))
			{
				m_outEnc = arg.substring(8);
			}
			else if (arg.startsWith("-outFile:"))
			{
				m_outFile = arg.substring(9);
			}
		}
	}
	
	public void readProperiesFile()
	{
		FileInputStream in = null;
		try
		{
			in = new FileInputStream("xml.properties");
			defaultProps.load(in);
			in.close();	
			Verification_String = defaultProps.getProperty("Description");
		}
		catch( Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	private String readFile(String name, String enc)
	{
		StringBuffer sb = new StringBuffer();
		
		BufferedReader input = null;
			//use buffering
			//this implementation reads one line at a time
			File f = new File(name);
			InputStreamReader isr;
			try
			{
				isr = new InputStreamReader(
						new FileInputStream(f), m_inEnc);
				input = new BufferedReader(isr);
				String line = null; //not declared within while loop
				while ((line = input.readLine()) != null)
				{
					sb.append(line);
				}
			}
			catch (UnsupportedEncodingException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (FileNotFoundException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (IOException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		
		return sb.toString();
	}

	private static void writeFile(String name, String enc, String data)
	{
		FileOutputStream fout;
		try
		{
			fout = new FileOutputStream(name);
			OutputStreamWriter out = new OutputStreamWriter(fout, enc); //
			out.write(data);
			out.flush();
			out.close();
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (UnsupportedEncodingException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args)
	{
		Util utl = new Util(args);
	}
}
